% Simon Says Game
% Michael Grieve
% July 19th, 2003

import GUI in "%oot/support/lib/Gui"
View.Set ("graphics:400;400")

% create a type called lightInfo
% stores the parallelport values corresponding to that light
% where the light is on the screen and the colour to turn the light when pressed
type lightInfo :
    record
	parallelOutValue : int
	parallelInValue : int
	x, y : int
	brightcolor : int
    end record

var pattern : array 1 .. 20 of lightInfo
var chooseLight : int

% clear all lights
procedure clearLights
    Draw.FillOval (100, 200, 50, 50, blue)
    Draw.FillOval (200, 100, 50, 50, green)
    Draw.FillOval (200, 300, 50, 50, red)
    Draw.FillOval (300, 200, 50, 50, magenta)
end clearLights

% displays the light that was pressed.
procedure showLight (whichLight : lightInfo, x : int)
    parallelput (whichLight.parallelOutValue)
    Draw.FillOval (whichLight.x, whichLight.y, 50, 50, whichLight.brightcolor)
    delay(1000-25*x)
    clearLights
    parallelput(0)
end showLight

% Display the increasing pattern of lights
procedure outputLightPattern (numberOfSteps : int)
    for i : 1 .. numberOfSteps
	showLight (pattern (i), i)
    end for
end outputLightPattern

% get input pattern, check if is valid pattern
function getInputPattern (numberOfSteps : int) : boolean
    for i : 1 .. numberOfSteps
	loop
	    exit when parallelget not= 120
	end loop
	if parallelget = pattern (i).parallelInValue then
	    showLight (pattern (i),i)
	else
	    result false
	end if
    end for
    result true
end getInputPattern

clearLights

% Fills the pattern array with a random pattern of 20 steps.
for i : 1 .. 20
    randint (chooseLight, 1, 4)
    if chooseLight = 1 then
	pattern (i).parallelOutValue := 1
	pattern (i).parallelInValue := 56
	pattern (i).x := 100
	pattern (i).y := 200
	pattern (i).brightcolor := 9
    elsif chooseLight = 2 then
	pattern (i).parallelOutValue := 2
	pattern (i).parallelInValue := 248
	pattern (i).x := 200
	pattern (i).y := 100
	pattern (i).brightcolor := 10
    elsif chooseLight = 3 then
	pattern (i).parallelOutValue := 4
	pattern (i).parallelInValue := 88
	pattern (i).x := 200
	pattern (i).y := 300
	pattern (i).brightcolor := 12
    else
	pattern (i).parallelOutValue := 8
	pattern (i).parallelInValue := 104
	pattern (i).x := 300
	pattern (i).y := 200
	pattern (i).brightcolor := 13
    end if
end for


% Start the game
for i: 1..20
    outputLightPattern(i)
    if getInputPattern(i) then
	locate(1,1)
	put "Level: ", i
    else
	locate(1,1)
	put "game over"
	parallelput(255)
	delay(1000)
	parallelput(0)
	exit
    end if
end for
    







